import { aws_cloudwatch as cloudwatch, aws_codebuild as cbuild, aws_events as events } from 'aws-cdk-lib';
import { Construct } from 'constructs';
import { ShellableProps } from './shellable';
export interface CanaryProps extends ShellableProps {
    /**
     * Rate at which to run the canary test.
     *
     * @default every 1 minute
     */
    schedule: events.Schedule;
}
/**
 * Schedules a script to run periodically in CodeBuild and exposes an alarm
 * for failures. Ideal for running 'canary' scripts.
 *
 * If not explicitly defined in `environmentVariables`, IS_CANARY is set to "true".
 */
export declare class Canary extends Construct {
    readonly alarm: cloudwatch.IAlarm;
    readonly project: cbuild.IProject;
    constructor(scope: Construct, id: string, props: CanaryProps);
}
