/**
 * Disables a CodePipeline transition into a given stage.
 * @param pipelineName the name of the pipeline on which a transition will be disabled.
 * @param stageName    the name of the stage into which a transition will be disabled.
 * @param reason       the reason to tag on the disabled transition
 */
export declare function disableTransition(pipelineName: string, stageName: string, reason: string): Promise<void>;
/**
 * Enables a CodePipeline transition into a given stage.
 * @param pipelineName the name of the pipeline on which a transition will be enabled.
 * @param stageName    the name of the stage into which a transition will be enabled.
 */
export declare function enableTransition(pipelineName: string, stageName: string): Promise<void>;
