/**
 * Handler for a lambda function that can be called periodically in order to enforce Change Control calendars. It
 * expects the following environment variables to be available:
 *
 * CHANGE_CONTROL_BUCKET_NAME - the name of the S3 Bucket containing the change control calendar
 * CHANGE_CONTROL_OBJECT_KEY  - the key in which the change control calendar is at in CHANGE_CONTROL_BUCKET_NAME
 * PIPELINE_NAME              - the name of the pipeline in which promotions will be managed
 * STAGE_NAME                 - the name of the stage into which transitions are managed
 */
export declare function handler(): Promise<void>;
