import * as AWS from 'aws-sdk';
export declare const codePipeline: AWS.CodePipeline;
/**
 * Lambda handler for the codepipeline state change events
 *
 * {
 *     "version": "0",
 *     "id": event_Id,
 *     "detail-type": "CodePipeline Pipeline Execution State Change",
 *     "source": "aws.codepipeline",
 *     "account": Pipeline_Account,
 *     "time": TimeStamp,
 *     "region": "us-east-1",
 *     "resources": [
 *         "arn:aws:codepipeline:us-east-1:account_ID:myPipeline"
 *     ],
 *     "detail": {
 *         "pipeline": "myPipeline",
 *         "version": "1",
 *         "state": "STARTED",
 *         "execution-id": execution_Id
 *     }
 * }
 */
export declare function handler(event: any): Promise<void>;
